package com.biganto.visual.roompark.base

import android.view.ViewGroup
import androidx.appcompat.widget.Toolbar
import androidx.coordinatorlayout.widget.CoordinatorLayout
import com.google.android.material.appbar.AppBarLayout
import com.google.android.material.bottomnavigation.BottomNavigationView
import com.google.android.material.textview.MaterialTextView

/**
 * Created by Vladislav Bogdashkin on 26.09.2019.
 */

interface ISupportActionBar{
    val topAppBar : Toolbar
    fun displayBackButton(show:Boolean)
    fun hideAll()
    fun showAll()
}

interface ICollapsingToolBar : ISupportActionBar{
    val appBar : AppBarLayout
    val coordinatorLayout: CoordinatorLayout
    fun appBarScrollable(allow:Boolean)
    val statusToolbar:ViewGroup
    val headerToolbar:ViewGroup
    val headerToolbarBack: MaterialTextView?
    fun setToolbar(header: HeaderToolbarModel? = null,status:StatusToolbarModel? = null)
}

interface IConductorActivity{
    val conductorContainer: ViewGroup
}

interface IBottomNavigation{
    val bottomNavigation : BottomNavigationView
    fun hide()
    fun show()
}


data class HeaderToolbarModel(
    val backButton:Boolean
    ,val backTitle:String?
    ,val title:String?
    ,val switcher:Boolean? = null)

data class StatusToolbarModel(val state:StatusState? = null
                              ,val stateTitle:String? = null
                              ,val meanTitle:String? = null)

enum class StatusState{AVAILABLE,SOLD_OUT}