package com.biganto.visual.roompark.conductor.dialogs.change_handler;

import android.animation.Animator;
import android.animation.AnimatorSet;
import android.animation.ObjectAnimator;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bluelinelabs.conductor.changehandler.AnimatorChangeHandler;

/**
 * Created by Vladislav Bogdashkin on 09.04.2019.
 */
public class DialogChangeHandler extends AnimatorChangeHandler {

    private static final int FadeInDuration = 240;

    public DialogChangeHandler() {
        super(false);
    }

    @NonNull
    @Override
    protected Animator getAnimator(@NonNull ViewGroup container, @Nullable View from, @Nullable View to, boolean isPush, boolean toAddedToContainer) {
        AnimatorSet animator = new AnimatorSet();
        if (to != null && toAddedToContainer) {
            ObjectAnimator anim = ObjectAnimator.ofFloat(to, View.ALPHA, 0, 1f);
            anim.setDuration(FadeInDuration);
            animator.play(anim);
        }
        return animator;
    }

    @Override
    protected void resetFromView(@NonNull View from) {
        // empty - Nothing to do with parent view
    }
}
