package com.biganto.visual.roompark.data.repository.api.retrofit.util

import com.biganto.visual.roompark.data.repository.api.retrofit.raw.ErrorRaw
import com.biganto.visual.roompark.domain.custom_exception.parseException
import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonDeserializer
import com.google.gson.JsonElement
import java.lang.reflect.Type


/**
 * Created by Vladislav Bogdashkin on 09.04.2019.
 */

class ErrorsListDeserializer: JsonDeserializer<List<ErrorRaw>> {
    override fun deserialize(json: JsonElement, typeOfT: Type, ctx: JsonDeserializationContext): List<ErrorRaw> {
        val vals = ArrayList<ErrorRaw>()
        when {
            json.isJsonArray -> for (e in json.asJsonArray) {
                vals.add(ctx.deserialize<Any>(e, ErrorRaw::class.java) as ErrorRaw)
            }
            json.isJsonObject -> vals.add(ctx.deserialize<Any>(json, ErrorRaw::class.java) as ErrorRaw)
            else -> throw RuntimeException("Unexpected JSON type: " + json.javaClass)
        }
        if (vals.isEmpty())
            return vals
        throw parseException(vals.first()) //-> for now throws only first!
    }
}