package com.biganto.visual.roompark.data.repository.api.retrofit.util;

import java.lang.annotation.Annotation;
import java.lang.reflect.Type;

import okhttp3.ResponseBody;
import retrofit2.Converter;
import retrofit2.Retrofit;

/**
 * Created by Vladislav Bogdashkin on 15.10.2018.
 */
public final class NullOnEmptyConverterFactory extends Converter.Factory {
    private NullOnEmptyConverterFactory() {
    }

    public static Converter.Factory create() {
        return new NullOnEmptyConverterFactory();
    }

    @Override
    public Converter<ResponseBody, ?> responseBodyConverter(Type type, Annotation[] annotations, Retrofit retrofit) {
        final Converter<ResponseBody, ?> delegate = retrofit.nextResponseBodyConverter(this, type, annotations);
        return (Converter<ResponseBody, Object>) body -> {
            if (body.contentLength() == 0) {
                return null;
            }
            if (body.contentLength() == 2/*equals OK*/)
//                    if (body.string().equals("OK")) -> can't read value because we can read stream only once
                    return null;
            return delegate.convert(body);
        };
    }
}