package com.biganto.visual.roompark.data.repository.api.retrofit.util

import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonDeserializer
import com.google.gson.JsonElement
import com.google.gson.JsonParseException
import java.lang.reflect.Type

/**
 * Created by Vladislav Bogdashkin on 09.04.2019.
 */

class SingleElementToListDeserializer<T>(private val clazz: Class<T>) : JsonDeserializer<List<T>> {

    @Throws(JsonParseException::class)
    override fun deserialize(json: JsonElement, typeOfT: Type, context: JsonDeserializationContext): List<T> {
        val resultList = arrayListOf<T>()
        if (json.isJsonArray) {
            for (e in json.asJsonArray) {
                resultList.add(context.deserialize<T>(e, clazz))
            }
        } else if (json.isJsonObject) {
            resultList.add(context.deserialize<T>(json, clazz))
        } else {
            throw RuntimeException("Unexpected JSON type: " + json.javaClass)
        }
        return resultList
    }
}