package com.biganto.visual.roompark.data.repository.db.requrey

import kotlinx.serialization.Serializable

/**
 * Created by Vladislav Bogdashkin on 15.06.2018.
 */

private fun revisionStringToString(revisionString:String):String
{val ind  = revisionString.indexOf('?'); return if (ind>0) (revisionString.substring(0,ind)) else revisionString } //remove revision flag

private fun revisionStringToRevision(revisionString:String):String?
{val ind  = revisionString.indexOf('?'); return if (ind>0) (revisionString.substring(ind)) else null} //remove revision flag


class RevisionString(private val value:String, private val revision:String?){
    constructor(revisionString:String) : this(
            value= revisionStringToString(revisionString),revision= revisionStringToRevision(revisionString)
    )

    fun uri()=value

    /**
     * @return full-string with revision
     */
    fun revisionUri()="$value${revision.orEmpty()}"
}



@Serializable
data class TitledPhoto(val title:String, val url:String){

    companion object{
        private const val delimiter = 'ø'
    }

    constructor(str:String) : this(
        title = str.substringBefore(delimiter),
        url = str.substringAfter(delimiter)
    )

    fun  delimiterString() = "$title$delimiter$url"
}


@Serializable
data class PhotoResolutions(
    val res_name:String,
    val url:String,
    val width:Int,
    val height:Int
) {
    companion object {
        private const val delimiter1 = 'ø'
        private const val delimiter2 = 'Õ'
        private const val delimiter3 = 'è'
    }

    constructor(str: String) : this(
        res_name = str.substringBefore(delimiter1),
        url = str.substringAfter(delimiter1).substringBefore(delimiter2),
        width = str.substringAfter(delimiter2).substringBefore(delimiter3).toInt(),
        height = str.substringAfter(delimiter3).toInt()
    )

    fun delimiterString() = "$res_name$delimiter1$url$delimiter2$width$delimiter3$height"
}