package com.biganto.visual.roompark.data.repository.db.requrey.model

import io.requery.*

/**
 * Created by Vladislav Bogdashkin on 29.10.2019.
 */


@Entity
interface Estate : Persistable {

    @get:Key
    val id: Int
    val type: String
    val number: String
    @get:Nullable
    val sectionBegin: Int?
    @get:Nullable
    val sectionEnd: Int?
    @get:Nullable
    val planJpgUrl: String?
    @get:Nullable
    val planJpgWidth: Int?
    @get:Nullable
    val planJpgHeight: Int?
    @get:Nullable
    val planPngUrl: String?
    @get:Nullable
    val planPngWidth: Int?
    @get:Nullable
    val planPngHeight: Int?

    @get:Nullable
    val rooms: Int?
    @get:Nullable
    val albumId: Int?
    @get:Nullable
    val multitourId: Int?

    @get:Nullable
    val multitourPreview: String?

    val info_building: Int
    val info_section_begin: Int
    val info_floor: Int
    val info_floor_max: Int
    @get:Nullable
    val url: String?
    @get:Nullable
    val info_area: Float?
    @get:Nullable
    val info_area_living: Float?
    @get:Nullable
    val info_kind: String?
    @get:Nullable
    val info_dependent: Boolean?
    @get:Nullable
    val info_decoration: String?
    @get:Nullable
    val info_window_face: String?
    @get:Nullable
    val info_price: Int?
    @get:Nullable
    val info_price_meter: Int?
    @get:Nullable
    val info_ceiling: Float?
    @get:Nullable
    val info_direction: String?

    val favorite : Boolean

    @get:Nullable
    @get:Column(name = "UserContainer")
    @get:ForeignKey(references = User::class )
    @get:OneToOne(mappedBy = "uuid",cascade = [CascadeAction.NONE])
    var user:User?
}