package com.biganto.visual.roompark.data.repository.db.requrey.model

import com.biganto.visual.roompark.data.repository.db.requrey.utils.StringListConverter
import io.requery.*

/**
 * Created by Vladislav Bogdashkin on 29.10.2019.
 */


@Entity
interface PlanPreset : Persistable {
    @get:Key
    @get:Generated
    val id: Int
    @get:ForeignKey(references = Estate::class)
    @get:ManyToOne(cascade = [CascadeAction.NONE])
    var estateId:Estate
    val planId: Int
    val title:String
    @get:Convert(StringListConverter::class)
    val features:List<String>
    @get:OneToMany( mappedBy = "owner", cascade = [CascadeAction.SAVE, CascadeAction.DELETE])
    val explication:MutableList<Explication>
}