package com.biganto.visual.roompark.data.repository.db.requrey.utils;

import java.util.ArrayList;

import io.requery.Converter;

/**
 * Created by Vladislav Bogdashkin on 04.07.2018.
 */


public class IntListConverter implements Converter<ArrayList<Integer>, String> {


    private final String stringDelimiter = ",";
    @SuppressWarnings("unchecked")
    @Override
    public Class<ArrayList<Integer>> getMappedType() {
        return (Class)ArrayList.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(ArrayList<Integer> value) {
        if (value == null) {
            return "";
        }
        StringBuilder sb = new StringBuilder();
        int index = 0;
        for (Integer str: value) {
            if (index > 0) {
                sb.append(stringDelimiter);
            }
            sb.append(str);
            index++;
        }
        return sb.toString();
    }

    @Override
    public ArrayList<Integer> convertToMapped(Class<? extends ArrayList<Integer>> type,
                                              String value) {
        ArrayList<Integer> list = new ArrayList<>();
        if (!value.isEmpty())
            for (String _val : value.split(stringDelimiter)) {
                list.add(Integer.parseInt(_val));
            }
        return list;
    }
}



