package com.biganto.visual.roompark.data.repository.db.requrey.utils;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import io.requery.Converter;
import timber.log.Timber;

/**
 * Created by Vladislav Bogdashkin on 04.07.2018.
 */


public class IsoDateConverter implements Converter<Date, String> {

    private SimpleDateFormat apiFormat =new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS+hh:mm", Locale.ROOT);
    //SimpleDateFormat dbFormat =new SimpleDateFormat("YYYYMMDDThhmmss", Locale.ROOT);

    @SuppressWarnings("unchecked")
    @Override
    public Class<Date> getMappedType() {
        return Date.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(Date value) {
        return value == null ? null : apiFormat.format(value);
    }

    @Override
    public Date convertToMapped(Class<? extends Date> type,
                                String value) {

        try {
            return value == null ? null : apiFormat.parse(value);
        }
        catch (Exception e){
            Timber.e("Wrong stored data format! {%s}",value);
            return new Date();
        }

    }
}