package com.biganto.visual.roompark.data.repository.db.requrey.utils;

import com.biganto.visual.roompark.data.repository.db.requrey.PhotoResolutions;

import java.util.ArrayList;
import java.util.List;

import io.requery.Converter;
import timber.log.Timber;

/**
 * Created by Vladislav Bogdashkin on 04.07.2018.
 */


public class PhotoResolutionsConverter implements Converter<List<PhotoResolutions>, String> {

    private static final String stringDelimeter="♀°♀";

    @SuppressWarnings("unchecked")
    @Override
    public Class<List<PhotoResolutions>> getMappedType() {
        return (Class) List.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(List<PhotoResolutions> value) {
        if (value == null) {
            return "";
        }
        StringBuilder sb = new StringBuilder();
        int index = 0;
        for (PhotoResolutions str: value) {
            if (index > 0) {
                sb.append(stringDelimeter);
            }
            sb.append(str.delimiterString());
            index++;
        }
        return sb.toString();
    }

    @Override
    public List<PhotoResolutions> convertToMapped(Class<? extends List<PhotoResolutions>> type,
                                String value) {
        try {
            ArrayList<PhotoResolutions> list = new ArrayList<>();
            if (value != null && !value.isEmpty())
                for (String s : value.split(stringDelimeter))
                    list.add(new PhotoResolutions(s));
            return list;
        }
        catch (Exception e){
            Timber.e("Wrong stored data format! {%s}",value);
            return new ArrayList<PhotoResolutions>(0);
        }

    }
}