package com.biganto.visual.roompark.data.repository.db.requrey.utils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import io.requery.Converter;

/**
 * Created by Vladislav Bogdashkin on 04.07.2018.
 */


public class StringListConverter implements Converter<List<String>, String> {

    private static final String stringDelimiter ="¹/|¹";

    @SuppressWarnings("unchecked")
    @Override
    public Class<List<String>> getMappedType() {
        return (Class)List.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(List<String> value) {
        if (value == null) {
            return "";
        }
        StringBuilder sb = new StringBuilder();
        int index = 0;
        for (String str: value) {
            if (index > 0) {
                sb.append(stringDelimiter);
            }
            sb.append(str);
            index++;
        }
        return sb.toString();
    }

    @Override
    public List<String> convertToMapped(Class<? extends List<String>> type,
                                              String value) {
        ArrayList<String> list = new ArrayList<>();
        if (value != null) {
            list.addAll(Arrays.asList(value.split(stringDelimiter)));
        }
        return list;
    }
}



