package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.StatusModel
import com.biganto.visual.roompark.domain.use_case.DealseUseCase
import io.reactivex.Observable
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class DealsInteractor @Inject constructor(
    val useCase:DealseUseCase
){

    fun fetchDeals() = useCase.getDeals()
//        Single.just(arrayListOf(dealFlat, dealParkign))
    fun getStatusList() = Observable.just(statusList.sortedBy{ it.orderId })

    companion object{

        val statusList = arrayListOf<StatusModel>(
            StatusModel(
                1,
                "Квартира забронирована за Вами. Скоро начнется подготовка договора",
                "Бронь"
            ),
            StatusModel(
                2,
                "Договор находится в процессе подготовки",
                "Подготовка договора"
            ),
            StatusModel(
                3,
                "Договор подготовлен и отправлен в офис продаж",
                "Договор подготовлен"
            ),
            StatusModel(
                4,
                "Договор находится в офисе продаж. Просим Вас приехать на подписание в назначенное время",
                "Договор готов к подписанию"
            ),
            StatusModel(
                5,
                "Договор передан на подписание Застройщику",
                "ДДУ подписан с покупателем"
            ),
            StatusModel(
                6,
                "Договор подписан Застройщиком",
                "Договор подписан"
            ),
            StatusModel(
                7,
                "Договор скоро будет отправлен в Росреестр",
                "Договор готовится для подачи на гос. регистрацию"
            ),
            StatusModel(
                8,
                "Договор передан в Росреестр для гос. регистрации",
                "Договор на регистрации"
            ),
            StatusModel(
                9,
                "Ваш договор успешно зарегистрирован в Росреестре",
                "Зарегистрирован"
            ),
            StatusModel(
                10,
                "Договор находится в офисе продаж. Вы можете забрать его в любое время",
                "Договор готов к выдаче"
            ),
            StatusModel(
                11,
                "Договор выдан",
                "Договор выдан"
            )
        )
    }
}