package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.PlanPresetModel
import com.biganto.visual.roompark.domain.use_case.EstateUseCase
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class EstateInteractor @Inject constructor(
    private val useCase: EstateUseCase
){

    fun getEstate(estateId:Int) = useCase.getEstate(estateId)

    fun getPlanTypes(estateId: Int) =
        useCase.getEstatePlanPresets(estateId)

    fun getPlan(estateId: Int,planId:Int) = useCase.getPlan(estateId,planId)

    fun getPlan(plan:PlanPresetModel) =
        useCase.getPlan(
            plan.estateId
            ,plan.planId
        ,furniture = plan.features.firstOrNull { it.featureName == "furniture" }?.switchedOn
        ,sizes = plan.features.firstOrNull { it.featureName == "sizes" }?.switchedOn
        ,walls = plan.features.firstOrNull { it.featureName == "walls" }?.switchedOn
        ,electric = plan.features.firstOrNull { it.featureName == "electric" }?.switchedOn
        )

}