package com.biganto.visual.roompark.domain.model

/**
 * Created by Vladislav Bogdashkin on 24.09.2019.
 */

data class PlanTypeModel(
    val id:Int,
    val planTypeId:Int,
    val estateId:Int,
    val features:List<FeatureModel>,
    val uri:String
)

sealed class FeatureModel(
    val featureName:String,
    val featureTitle:String,
    var switchedOn: Boolean
){
    companion object{
        fun fromFeature(featureAlias:String):FeatureModel =
            when(featureAlias){
                "furniture" -> Furniture()
                "sizes" -> Sizes()
                "electric" -> Electric()
                "walls" -> Walls()
                else -> error("Unsupported feature type")
            }
    }
    class Furniture:FeatureModel("furniture","Мебель",false)
    class Sizes:FeatureModel("sizes","Размеры",false)
    class Electric:FeatureModel("electric","Электрика",false)
    class Walls:FeatureModel("walls","Перегородки",true)



}



