package com.biganto.visual.roompark.domain.use_case

import com.biganto.visual.roompark.domain.contract.FeedsContract
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 24.09.2019.
 */

class FeedUseCase @Inject constructor(
    private val contract: FeedsContract
){
    fun getFeeds() = contract.fetchFeeds()

    fun getArticles(feedAlias:String) =
        contract.fetchFeedObservable(feedAlias)

    fun fetchArticlesPage(feedAlias:String,pageSize:Int,startIndex:Int) =
        contract.fetchFeedObservable(feedAlias,pageSize,startIndex)


    fun getArticle(articleId:Int) =
        contract.getArticle(articleId)

    fun setRead(articleId: Int) = contract.articleRead(articleId)
}