package com.biganto.visual.roompark.domain.use_case

import com.biganto.visual.roompark.domain.contract.DeviceUtilsContract
import com.biganto.visual.roompark.domain.contract.SubscriptionContract
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 01.11.2019.
 */

class SubscriptionUseCase @Inject constructor(
    private val subscription: SubscriptionContract,
    private val utils: DeviceUtilsContract
){

    fun subscribeTopic(topic:String, topicId:String?=null) =
        utils.getDeviceId()
            .flatMap{deviceToken -> subscription.subscribeTopic(
                deviceToken,
                topic,
                topicId
            ) }

    fun unSubscribeTopic(topic:String, topicId:String?=null) =
        utils.getDeviceId()
            .flatMap{deviceToken -> subscription.unSubscribeTopic(
                deviceToken,
                topic,
                topicId
            ) }



}