package com.biganto.visual.roompark.presentation.screen.albums.util

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.domain.model.AlbumPreviewModel
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.bumptech.glide.Glide
import com.bumptech.glide.load.engine.DiskCacheStrategy


/**
 * Created by Vladislav Bogdashkin on 15.10.2019.
 */
class AlbumsHeaderAdapter : CommonRecyclerAdapter<AlbumsHeaderViewHolder, AlbumPreviewModel>() {

    override val vhKlazz = AlbumsHeaderViewHolder::class

    override fun getVhLayout(): Int = R.layout.album_header_preview_viewholder

    fun getItemPosition(model: AlbumPreviewModel) = getItemPosition(model.albumId)

    fun getItemPosition(modelId: Int) = list.indexOfFirst {
        it.albumId == modelId
    }
}


class AlbumsHeaderViewHolder(itemView: View) : CommonViewHolder<AlbumPreviewModel>(itemView) {

    @BindView(R.id.preview) lateinit var preview:ImageView
    @BindView(R.id.card_title) lateinit var articleTitle:TextView
    @BindView(R.id.card_updated) lateinit var articleDate:TextView

    override fun onViewBound(model: AlbumPreviewModel) {
        articleTitle.text = model.title
        Glide.with(itemView)
            .load(model.previewUrl)
            .centerCrop()
            .fitCenter()
            .diskCacheStrategy(DiskCacheStrategy.ALL)
            .into(preview)
    }
}
