package com.biganto.visual.roompark.presentation.screen.article.util

import android.view.View
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.data.repository.db.requrey.TitledPhoto
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.biganto.visual.roompark.util.view_utils.image_view.RoundedImageView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.engine.DiskCacheStrategy
import kotlin.reflect.KClass

/**
 * Created by Vladislav Bogdashkin on 29.01.2020.
 */



class ArticleBottomPhotoAdapter : CommonRecyclerAdapter<ArticleBottomPhotoViewHolder,TitledPhoto>() {
    override val vhKlazz: KClass<ArticleBottomPhotoViewHolder>
        get() = ArticleBottomPhotoViewHolder::class

    override fun getVhLayout(): Int = R.layout.photo_article_slider_viewholder

}

class ArticleBottomPhotoViewHolder(itemView: View) : CommonViewHolder<TitledPhoto>(itemView){

    override fun onViewBound(model: TitledPhoto) {
//        articleTitle.text = model.title
        Glide.with(itemView)
            .load(model.url)
            .centerCrop()
            .fitCenter()
            .diskCacheStrategy(DiskCacheStrategy.ALL)
            .into((itemView as RoundedImageView))
    }

}
