package com.biganto.visual.roompark.presentation.screen.auth

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

sealed class AuthScreenViewState : BigantoBaseViewState() {
    class Idle : AuthScreenViewState()
    class Authorization : AuthScreenViewState()
    class SignedIn : AuthScreenViewState()
    class SignInError(val exception: ExceptionString) : AuthScreenViewState()
    class SomeError(val exception: ExceptionString) : AuthScreenViewState()
    class WrongLogin(val exception: ExceptionString) : AuthScreenViewState()
    class WrongPassword(val exception: ExceptionString) : AuthScreenViewState()

}