package com.biganto.visual.roompark.presentation.screen.deal

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module
import javax.inject.Named


@PerScreen
@Component(
    modules = [DealScreenModule::class],
    dependencies = [AppComponent::class])
interface DealScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
            ,@BindsInstance @Named(SELECTED_DEAL_ID_KEY) selectedDealId:String
        ): DealScreenComponent
    }

    val presenter: DealScreenPresenter

    fun inject(controller: DealScreenController)
}

@Module
abstract class DealScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

}
