package com.biganto.visual.roompark.presentation.screen.deals

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [DealsScreenModule::class],
    dependencies = [AppComponent::class])
interface DealsScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): DealsScreenComponent
    }

    val presenter: DealsScreenPresenter

    fun inject(controller: DealsScreenController)
}

@Module
abstract class DealsScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

}
