package com.biganto.visual.roompark.presentation.screen.estate

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.EstateModel
import com.biganto.visual.roompark.domain.model.PlanPresetModel
import com.biganto.visual.roompark.presentation.screen.estate.util.DisplayInfoModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class EstateScreenViewState : BigantoBaseViewState() {
    class Idle : EstateScreenViewState()
    class LoadEstate(val estate:EstateModel) : EstateScreenViewState()
    class LoadPlanTypes(val types:List<PlanPresetModel>) : EstateScreenViewState()
    class PlanTypeSelected(val item:PlanPresetModel) : EstateScreenViewState()
    class LoadPlan(val planBody:String) : EstateScreenViewState()
    class SomeError(val exception: ExceptionString) : EstateScreenViewState()
    class ShowEstateInfo(val showType: InfoShowType, val info:List<DisplayInfoModel>) : EstateScreenViewState()
}