package com.biganto.visual.roompark.presentation.screen.estate.util

import android.view.View
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.google.android.material.textview.MaterialTextView

/**
 * Created by Vladislav Bogdashkin on 16.10.2019.
 */


class FlatInfoAdapter : CommonRecyclerAdapter<FlatInfoViewHolder, DisplayInfoModel>() {

    override val vhKlazz = FlatInfoViewHolder::class

    override fun getVhLayout(): Int = R.layout.flate_measure_info_viewholder

    override fun onBindViewHolder(holder: FlatInfoViewHolder, position: Int) {
        super.onBindViewHolder(holder, position)
        if (position%2 == 0)
            holder.itemView.background = holder.itemView.context.getDrawable(R.color.colorDividerLightGray)
        else
            holder.itemView.background = holder.itemView.context.getDrawable(R.color.colorPrimary)
    }
}


class FlatInfoViewHolder(itemView: View) : CommonViewHolder<DisplayInfoModel>(itemView) {

    @BindView(R.id.flat_measure_description)
    lateinit var infoTitle:MaterialTextView

    @BindView(R.id.flat_measure_value)
    lateinit var infoValue:MaterialTextView

    override fun onViewBound(model: DisplayInfoModel) {
        infoTitle.text = model.langTitle
        infoValue.text = model.langValue
    }

}

data class DisplayInfoModel(val langTitle:String, val langValue:String)