package com.biganto.visual.roompark.presentation.screen.favorites

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [FavoritesScreenModule::class],
    dependencies = [AppComponent::class])
interface FavoritesScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): FavoritesScreenComponent
    }

    val presenter: FavoritesScreenPresenter

    fun inject(controller: FavoritesScreenController)
}

@Module
abstract class FavoritesScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

}
