package com.biganto.visual.roompark.presentation.screen.feed_list

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module
import javax.inject.Named


@PerScreen
@Component(
    modules = [ArticlesScreenModule::class],
    dependencies = [AppComponent::class])
interface ArticlesScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            @BindsInstance @Named(FEED_ALIAS) feed:String
            , appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): ArticlesScreenComponent
    }

    val presenter: ArticlesScreenPresenter

    fun inject(controller: ArticlesScreenController)
}

@Module
abstract class ArticlesScreenModule{

    @PerScreen
    @Binds
    abstract fun provideContext(activity: RoomParkMainActivity): Context


    @PerScreen
    @Binds
    abstract fun provideFeedId(@Named("FEED_ID_INT") feedId:Int) : Int

}
