package com.biganto.visual.roompark.presentation.screen.feed_list.util

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.domain.model.ArticlePreviewModel
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.biganto.visual.roompark.util.extensions.setGone
import com.bumptech.glide.Glide
import com.bumptech.glide.load.engine.DiskCacheStrategy
import timber.log.Timber
import java.text.SimpleDateFormat
import java.util.*

/**
 * Created by Vladislav Bogdashkin on 16.10.2019.
 */

class ArticlesAdapter : CommonRecyclerAdapter<ArticleViewHolder, ArticlePreviewModel>() {

    override val vhKlazz = ArticleViewHolder::class

    override fun getVhLayout(): Int = R.layout.feed_direct_viewholder

}


class ArticleViewHolder(itemView: View) : CommonViewHolder<ArticlePreviewModel>(itemView) {

    private val dateFormatter = SimpleDateFormat("dd / MM / yyyy", Locale.getDefault())

    @BindView(R.id.imageHolder) lateinit var preview: ImageView
    @BindView(R.id.feed_date_text_view) lateinit var articleDate: TextView
    @BindView(R.id.feed_title_info_text_view) lateinit var articleTitle: TextView
    @BindView(R.id.feed_read) lateinit var articleIsRead:View



    override fun onViewBound(model: ArticlePreviewModel) {
        Timber.d("readeed?: ${model.isRead} of ${model.title}")
        articleDate.text = dateFormatter.format(model.published)
        articleTitle.text = model.title
        articleIsRead.setGone(model.isRead)

        Glide.with(preview)
            .load(model.previewUrl)
            .diskCacheStrategy(DiskCacheStrategy.ALL)
            .into(preview)
    }

}