package com.biganto.visual.roompark.presentation.screen.feeds

import com.biganto.visual.roompark.conductor.BigantoBaseContract
import com.biganto.visual.roompark.domain.model.AlbumPreviewModel
import com.biganto.visual.roompark.domain.model.ArticlePreviewModel
import com.biganto.visual.roompark.domain.model.FeedModel
import com.biganto.visual.roompark.domain.model.WebCamModel
import io.reactivex.Observable

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

interface FeedsScreen : BigantoBaseContract<FeedsScreenViewState> {
    fun feedsTabSelected(): Observable<String>
    fun requsetsNewArticles(): Observable<Pair<FeedModel, Int>>
    fun onAllFeedArticles(): Observable<FeedModel>
    fun onCameraSelected(): Observable<WebCamModel>
    fun onArticleSelected(): Observable<ArticlePreviewModel>
    fun onAlbumSelected(): Observable<AlbumPreviewModel>
}


data class EstateTabModel(val title:String, val building:Int)