package com.biganto.visual.roompark.presentation.screen.feeds

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.data.service.user_session.IUserSession
import com.biganto.visual.roompark.data.service.user_session.UserSessionService
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [FeedsScreenModule::class]
    ,dependencies = [AppComponent::class]
)
interface FeedsScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): FeedsScreenComponent
    }

    fun inject(controller: FeedsScreenController)
}

@Module
abstract class FeedsScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

//    @PerScreen
//    @Binds
//    abstract fun provideContract(impl: FeedsContractModule): FeedsContract
//
//    @PerScreen
//    @Binds
//    abstract fun provideDevContract(impl: AlbumsContractModule): DevProgressContract


    @PerScreen
    @Binds
    abstract fun provideSession(impl: UserSessionService): IUserSession

}
