package com.biganto.visual.roompark.presentation.screen.home

import android.view.View
import androidx.viewpager.widget.ViewPager
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.biganto.visual.roompark.presentation.screen.deals.DealsScreenController
import com.biganto.visual.roompark.presentation.screen.favorites.FavoritesScreenController
import com.biganto.visual.roompark.presentation.screen.feeds.FeedsScreenController
import com.biganto.visual.roompark.presentation.screen.settings.SettingsScreenController
import com.biganto.visual.roompark.presentation.screen.to_flat.FindFlatScreenController
import com.google.android.material.bottomnavigation.BottomNavigationView
import timber.log.Timber
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 11.10.2019.
 */


@Deprecated("Реализация через ViewPager сулит некоторые дополнительны проблемы и оверхед")
class HomeController :
    BigantoBaseController<HomeScreenViewState
            , HomeScreen
            , HomeScreenPresenter>()
    , HomeScreen {

    override fun onViewBound(v: View) {
        bottomNavigationController.bottomNavigation.visibility = BottomNavigationView.VISIBLE
        viewpager.offscreenPageLimit = 0
        pageAdapter = BNVRouterPagerAdapter(this,bottomNavigationController.bottomNavigation,viewpager,
            mapOf(
                Pair(R.id.tab_feeds,{FeedsScreenController()})
                ,Pair(R.id.tab_favorites,{ FavoritesScreenController() })
                ,Pair(R.id.tab_deals,{ DealsScreenController() })
                ,Pair(R.id.tab_look_flat,{ FindFlatScreenController() })
                ,Pair(R.id.tab_settings,{SettingsScreenController()})
            )
        )
    }

    override fun injectDependencies() {
        getComponent()
    }

    @BindView(R.id.home_router_host)
    lateinit var viewpager: ViewPager

    @Inject
    override lateinit var injectedPresenter: HomeScreenPresenter

    private lateinit var pageAdapter : BNVRouterPagerAdapter

    fun getComponent() = DaggerHomeScreenComponent
        .factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity)
        .inject(this)

    override fun render(viewState: HomeScreenViewState) {
        when(viewState){
            is HomeScreenViewState.Idle -> render(viewState)
            is HomeScreenViewState.ToScreen -> render(viewState)
        }
    }

    private fun render(viewState: HomeScreenViewState.Idle){
    }

    private fun render(viewState: HomeScreenViewState.ToScreen){
    }


    override fun getLayoutId(): Int = R.layout.home_screen_viewpager

    override fun handleBack(): Boolean {
        Timber.d("handle back in class ")

        val childRouter = pageAdapter.currentPrimaryRouter

        if (childRouter != null) {
            val backStackSizeCondition = childRouter.backstackSize < 2
            val backStackResult = childRouter.handleBack()
            if (backStackResult
                && backStackSizeCondition
            )
            return backStackResult

        } else {
            Timber.e(IllegalStateException(
                    "handleBack called with getChildRouter(currentlySelectedItemId) == null.")
            ,"handleBack called with getChildRouter(currentlySelectedItemId) == null.")
        }
        return false
    }


}