package com.biganto.visual.roompark.presentation.screen.home

import android.content.Context
import com.biganto.visual.roompark.base.IBottomNavigation
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.data.data_provider.AuthContractModule
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import com.biganto.visual.roompark.domain.contract.AuthContract
import com.biganto.visual.roompark.presentation.screen.home.home_routing.HomeBottomNavigationController
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module

///**
// * Created by Vladislav Bogdashkin on 30.09.2019.
// */

@PerScreen
@Component(
    modules = [HomeScreenModule::class],
    dependencies = [AppComponent::class])
interface HomeScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): HomeScreenComponent
    }

    val presenter: HomeScreenPresenter

    fun inject(controller: HomeController)
    fun inject(controller: HomeBottomNavigationController)
}

@Module
abstract class HomeScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

    @PerScreen
    @Binds
    abstract fun provideAuth(contract: AuthContractModule): AuthContract

    @PerScreen
    @Binds
    abstract fun provideToolbar(activitiy: RoomParkMainActivity): ICollapsingToolBar

    @PerScreen
    @Binds
    abstract fun provideBottomNavigation(activitiy: RoomParkMainActivity): IBottomNavigation
}
