package com.biganto.visual.roompark.presentation.screen.photo

import android.content.Context
import com.biganto.visual.roompark.base.IBottomNavigation
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module
import javax.inject.Named

///**
// * Created by Vladislav Bogdashkin on 30.09.2019.
// */

@PerScreen
@Component(
    modules = [PhotoScreenModule::class]
    ,dependencies = [AppComponent::class]
)
interface PhotoScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
            ,@BindsInstance @Named(SELECTED_PHOTO_KEY) camIndex:Int
        ): PhotoScreenComponent
    }

    fun inject(controller: PhotoScreenController)
}

@Module
abstract class PhotoScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

    @PerScreen
    @Binds
    abstract fun provideBottomNavigation(activitiy: RoomParkMainActivity): IBottomNavigation

}
