package com.biganto.visual.roompark.presentation.screen.photo

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.AlbumPreviewModel
import com.biganto.visual.roompark.domain.model.PhotoModel
import com.biganto.visual.roompark.domain.model.PhotoResolutionModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class PhotoScreenViewState : BigantoBaseViewState() {
    class Idle : PhotoScreenViewState()
    class PhotoListLoaded(val list:List<PhotoModel>,val selectedId:Int) : PhotoScreenViewState()
    class PhotoFetched(val model:PhotoModel) : PhotoScreenViewState()
    class PhotoSelected(val model:PhotoResolutionModel) : PhotoScreenViewState()
    class SomeError(val exception: ExceptionString) : PhotoScreenViewState()
    class AldumFetched(val model:AlbumPreviewModel) : PhotoScreenViewState()
}