package com.biganto.visual.roompark.presentation.screen.to_flat

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.PerScreen
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [FindFlatScreenModule::class],
    dependencies = [AppComponent::class])
interface FindFlatScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): FindFlatScreenComponent
    }

    val presenter: FindFlatScreenPresenter

    fun inject(controller: FindFlatScreenController)
}

@Module
abstract class FindFlatScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

}
