package com.biganto.visual.roompark.util.monades

import androidx.annotation.StringRes
import com.biganto.visual.roompark.domain.custom_exception.CustomApiException

/**
 * Created by Vladislav Bogdashkin on 12.11.2019.
 */

sealed class Either<out E, out V> {
    data class Left<out E>(val left: E) : Either<E, Nothing>()
    data class Right<out V>(val right: V) : Either<Nothing, V>()



}


data class ExceptionString(@StringRes private val stringId: Int?, private  val message: String?) {



    fun selectHandler(a1:(Int)->Unit,a2:(String)->Unit) =
        when(errorMessage){
            is Either.Left -> a1(errorMessage.left)
            is Either.Right -> a2(errorMessage.right)
        }

    constructor(e:CustomApiException) : this(
        if (e.customMessage!=null) null else e.messageStringId,
        e.customMessage
    )

    val errorMessage : Either<Int,String> = if (stringId!=null) Either.Left(stringId) else Either.Right(message!!)

//    init {
//        Timber.d(" messages: $stringId / $message")
//        if (stringId==null && message==null) throw  error{ "both values cannot be null!" }
//        errorMessage = if (stringId!=null) Either.Left(stringId) else Either.Right(message!!)
//    }

}
