package com.biganto.visual.roompark.util.view_utils.grid

import android.graphics.Rect
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.RecyclerView.NO_POSITION
import androidx.recyclerview.widget.StaggeredGridLayoutManager

/**
 * Created by Vladislav Bogdashkin on 04.06.2019.
 */

class CeilsDecoration(private val spanCount:Int, private val spacing:Int? = 0)
    : RecyclerView.ItemDecoration
() {

    override fun getItemOffsets(outRect: Rect, view: View,
                                parent: RecyclerView, state: RecyclerView.State) {

        val layoutParams = view.layoutParams as? StaggeredGridLayoutManager.LayoutParams? ?: return

        if (layoutParams.isFullSpan) {
            val adapterPosition= layoutParams.viewAdapterPosition
            var topMargin = 0
            if (adapterPosition != NO_POSITION)
                if (adapterPosition!=0)
                    topMargin=(spacing?:0)/2
            outRect.set(0, topMargin, 0, 0)
            return
        }

            val spanIndex = layoutParams.spanIndex
            val layoutPosition = layoutParams.viewLayoutPosition
            val itemCount = parent.adapter?.itemCount?:0

            val leftEdge = spanIndex == 0
            val rightEdge = spanIndex == spanCount - 1

            val topEdge = spanIndex < spanCount
            val bottomEdge = layoutPosition >= itemCount - spanCount

            spacing?.let {
                outRect.set(
                        if (leftEdge) it else it/2,
                        if (topEdge) it else it/2,
                        if (rightEdge) it else it/2,
                        if (bottomEdge) it else it/2
                )
            }?:outRect.set(0,0,0,0)

    }
}