package com.biganto.visual.roompark.util.view_utils.html

import android.text.Editable
import android.text.Html
import android.text.Spannable
import android.text.Spanned
import android.text.style.TypefaceSpan
import org.xml.sax.XMLReader
import timber.log.Timber

/**
 * Created by Vladislav Bogdashkin on 02.12.2019.
 */


class HtmlTagHandler : Html.TagHandler {
    override fun handleTag(opening: Boolean, tag: String, output: Editable, xmlReader: XMLReader) {
        Timber.e(tag,"Tag" )
        if (tag.startsWith("b")) {
            Timber.d( "Code tag encountered1")
            if (opening) {
                Timber.d("Code tag encountered1")
                output.setSpan(
                    TypefaceSpan("monospace"),
                    output.length,
                    output.length,
                    Spannable.SPAN_MARK_MARK
                )
            } else {
                Timber.d("Code tag encountered2")
                val obj = getLast(output, TypefaceSpan::class.java)
                val where = output.getSpanStart(obj)
                output.removeSpan(obj)
                output.setSpan(
                    TypefaceSpan("monospace"),
                    where,
                    output.length,
                    Spanned.SPAN_EXCLUSIVE_EXCLUSIVE
                )
            }
        } else {
            Timber.d("Code Exited")
        }

    }

    private fun getLast(text: Editable, kind: Class<*>): Any? {

        val objs = text.getSpans(0, text.length, kind)
        if (objs.isEmpty()) {
            return null
        } else {
            for (i in objs.size downTo 1) {
                if (text.getSpanFlags(objs[i - 1]) == Spannable.SPAN_MARK_MARK) {
                    return objs[i - 1]
                }
            }
            return null
        }
    }
}